unit PleaseWait;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TPleaseWaitForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    NumberOfFilesLabel: TLabel;
    BitBtn1: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
    FCancelled      : Boolean;
    FNumberOfFiles  : integer;
    NumberOfUpdates : integer;
    procedure SetNumberOfFiles(Value: integer);
  public
    { Public declarations }
  published
    property NumberOfFiles : integer read FNumberOfFiles write SetNumberOfFiles;
    property Cancelled     : Boolean read FCancelled;
  end;

var
  PleaseWaitForm: TPleaseWaitForm;

implementation

{$R *.DFM}

procedure TPleaseWaitForm.SetNumberOfFiles(Value: integer);
begin
  if (FNumberOfFiles <> Value) and (Value > 0) then
  begin
    FNumberOfFiles := Value;
    NumberOfFilesLabel.Caption := IntToStr(FNumberOfFiles);

    Inc(NumberOfUpdates);
    if NumberOfUpdates > 2 then // try to reduce hyperactivity and flicker
    begin
      Application.ProcessMessages;
      NumberOfUpdates := 0;
    end;
  end;
end;

procedure TPleaseWaitForm.BitBtn1Click(Sender: TObject);
begin
  FCancelled := True;
end;

initialization
  PleaseWaitForm := nil;
end.
